#ifdef GL_ES
precision mediump float;
#endif
uniform sampler2D imgTexture;

uniform lowp int inkEffect;
uniform lowp vec4 blendColor;

uniform float fB;
uniform vec2 scale;
uniform vec2 offset;
uniform lowp int pDir;

varying vec2 textureCoordinate;

void main()
{
	vec2 posTex;
	float fC;
	
	vec4 color = vec4(0.0, 0.0, 0.0, 1.0);
	
	if(pDir == 0)
	{
		//fC =  max(0.02, 1.0+(fB - 1.0)*4.0*pow((texCoordinate.s-0.5),2.0));
		fC = 1.0 + sin(textureCoordinate.s*3.1415)*fB - fB;
		posTex = textureCoordinate * vec2(1.0, fC) + vec2(0.0, (1.0-fC)/2.0);
		color = texture2D(imgTexture, posTex*scale+offset) * blendColor;
	}
	
	if(pDir == 1)
	{
		//fC =  max(0.05, 1.0+(fB - 1.0)*4.0*pow((texCoordinate.t-0.5),2.0));
		fC = 1.0 + sin(textureCoordinate.t*3.1415)*fB - fB; //height for horizontal, width for vertical
		posTex = textureCoordinate * vec2(fC, 1.0) + vec2((1.0-fC)/2.0, 0.0);
		color = texture2D(imgTexture, posTex*scale+offset) * blendColor;
	}

	if(inkEffect == 2)			//INVERT
		color.rgb = vec3(1,1,1)-color.rgb;
	else if(inkEffect == 10)	//MONO
	{
		lowp float mono = 0.3125*color.r + 0.5625*color.g + 0.125*color.b;
		color.rgb = vec3(mono,mono,mono);
	}
	
	gl_FragColor = color;
}
