#ifdef GL_ES
precision mediump float;
#endif
uniform sampler2D imgTexture;
varying vec2 textureCoordinate;

uniform lowp int inkEffect;
uniform lowp vec4 blendColor;

uniform float Zoom;
uniform float WaveIncrement;
uniform float Offset;
uniform int Mode;

uniform vec2 scale;
uniform vec2 offset;
uniform int pDir;

#define delta 3.141592/180.0

void main()
{
    lowp vec4 color = vec4(0.0, 0.0, 0.0, 0.0);
    mediump vec2 posTex;

    if(pDir == 0)
    {
        mediump float ty = textureCoordinate.y;

        if(Mode == 0)
            ty = 1.0-ty;

        float ScreenX = 1.0 + sin((ty*WaveIncrement+Offset)*delta)*Zoom;
        posTex = (textureCoordinate + vec2((1.0-ScreenX)/2.0, 0.0))*scale+offset;
        color = texture2D(imgTexture, posTex);
    }
    else
    {
        mediump float tx = textureCoordinate.x*WaveIncrement+Offset;

        if(Mode == 0)
            tx *= +1.0;
        else
            tx *= -1.0;

        float ScreenY = 1.0 - sin(tx*delta)*Zoom;
        posTex = (textureCoordinate+ vec2(0.0, (2.0-2.0*ScreenY)/2.0))*scale+offset;
        color = texture2D(imgTexture, posTex);
    }
    color *= blendColor;

    if(inkEffect == 2)			//INVERT
    color.rgb = vec3(1,1,1)-color.rgb;
    else if(inkEffect == 10)	//MONO
    {
        lowp float mono = 0.3125*color.r + 0.5625*color.g + 0.125*color.b;
        color.rgb = vec3(mono,mono,mono);
    }

    gl_FragColor = color;
}