#ifdef GL_ES
precision mediump float;
#endif
uniform sampler2D imgTexture;
varying vec2 textureCoordinate;

uniform lowp int inkEffect;
uniform lowp vec4 blendColor;

uniform float Zoom;
uniform float WaveIncrement;
uniform float Offset;
uniform int Mode;

uniform vec2 scale;
uniform vec2 offset;
uniform int pDir;

#define delta 3.141592/180.0

void main()
{
    lowp vec4 color = vec4(0.0, 0.0, 0.0, 0.0);
    mediump vec2 posTex;

    if(pDir != 0)
    {
        float y= textureCoordinate.y;
        if(Mode == 0)
            y = (1.0-y);

        float ScreenX = 1.0 + sin((y*WaveIncrement+Offset)*delta)*Zoom-Zoom;
        posTex = textureCoordinate * vec2(ScreenX, 1.0) + vec2((1.0-ScreenX)/2.0, 0.0);
        color = texture2D(imgTexture, posTex*scale+offset);
    }
    else
    {
        float ScreenY = 1.0 + sin((textureCoordinate.x*WaveIncrement+Offset)*delta)*Zoom-Zoom;
        posTex = textureCoordinate * vec2(1.0, ScreenY) + vec2(0.0, (1.0-ScreenY)/2.0);
        color = texture2D(imgTexture, posTex*scale+offset);
    }
    color *= blendColor;

    if(inkEffect == 2)			//INVERT
    color.rgb = vec3(1,1,1)-color.rgb;
    else if(inkEffect == 10)	//MONO
    {
        lowp float mono = 0.3125*color.r + 0.5625*color.g + 0.125*color.b;
        color.rgb = vec3(mono,mono,mono);
    }

    gl_FragColor = color;
}